#version 330 core

// Ouput data
layout(location = 0) out vec4 color;

uniform sampler2D tex;

in vec2 UV;

float LinearizeDepth(float depth)
{
    float z = depth * 2.0 - 1.0; // Back to NDC 
    return (2.0 * 0.1f * 1000.0f) / (1000.0f + 0.1f - z * (1000.0f - 0.1f));
}

void main(){
	/*float Znear = 1.0;
	float Zfar = 100.0;
	float Q  = Zfar / ( Zfar - Znear );
	float inv_Zfar = 1.0 / Zfar;

	float depth = texture(tex, UV).x;
    float linearDepth = inv_Zfar / (Q - depth);
	color = vec4(linearDepth);*/
	
	float depthValue = texture(tex, UV).r;
	color = vec4(vec3(LinearizeDepth(depthValue) / 1000.0f), 1.0); // perspective
	//color = vec4(vec3(depthValue), 1.0); // orthographic
}
